package sun.awt.image;

import java.awt.Rectangle;
import java.awt.Point;
import java.awt.image.SampleModel;
import sun.java2d.SurfaceData;
import java.awt.Image;
import sun.java2d.StateTrackable;
import java.awt.image.DataBuffer;
import java.awt.image.DataBufferInt;
import java.awt.image.DataBufferUShort;
import java.awt.image.DataBufferByte;
import sun.java2d.StateTrackableDelegate;
import java.awt.image.WritableRaster;

public class SunWritableRaster extends WritableRaster
{
    private static SunWritableRaster.DataStealer stealer;
    private StateTrackableDelegate theTrackable;
    
    public static void setDataStealer(SunWritableRaster.DataStealer stealer) {
        if (SunWritableRaster.stealer != null) {
            throw new InternalError("Attempt to set DataStealer twice");
        }
        SunWritableRaster.stealer = stealer;
        return;
    }
    
    public static byte[] stealData(DataBufferByte dataBufferByte, int n) {
        return SunWritableRaster.stealer.getData(dataBufferByte, n);
    }
    
    public static short[] stealData(DataBufferUShort dataBufferUShort, int n) {
        return SunWritableRaster.stealer.getData(dataBufferUShort, n);
    }
    
    public static int[] stealData(DataBufferInt dataBufferInt, int n) {
        return SunWritableRaster.stealer.getData(dataBufferInt, n);
    }
    
    public static StateTrackableDelegate stealTrackable(DataBuffer dataBuffer) {
        return SunWritableRaster.stealer.getTrackable(dataBuffer);
    }
    
    public static void setTrackable(DataBuffer dataBuffer, StateTrackableDelegate stateTrackableDelegate) {
        SunWritableRaster.stealer.setTrackable(dataBuffer, stateTrackableDelegate);
    }
    
    public static void makeTrackable(DataBuffer dataBuffer) {
        SunWritableRaster.stealer.setTrackable(dataBuffer, StateTrackableDelegate.createInstance(StateTrackable.State.STABLE));
    }
    
    public static void markDirty(DataBuffer dataBuffer) {
        SunWritableRaster.stealer.getTrackable(dataBuffer).markDirty();
    }
    
    public static void markDirty(WritableRaster writableRaster) {
        if ((writableRaster instanceof SunWritableRaster)) {
            ((SunWritableRaster)writableRaster).markDirty();
        }
        else {
            markDirty(writableRaster.getDataBuffer());
        }
    }
    
    public static void markDirty(Image img) {
        SurfaceData.getPrimarySurfaceData(img).markDirty();
    }
    
    public SunWritableRaster(SampleModel sampleModel, Point origin) {
        super(sampleModel, origin);
        this.theTrackable = stealTrackable(this.dataBuffer);
    }
    
    public SunWritableRaster(SampleModel sampleModel, DataBuffer dataBuffer, Point origin) {
        super(sampleModel, dataBuffer, origin);
        this.theTrackable = stealTrackable(dataBuffer);
    }
    
    public SunWritableRaster(SampleModel sampleModel, DataBuffer dataBuffer, Rectangle aRegion, Point sampleModelTranslate, WritableRaster parent) {
        super(sampleModel, dataBuffer, aRegion, sampleModelTranslate, parent);
        this.theTrackable = stealTrackable(dataBuffer);
    }
    
    public final void markDirty() {
        this.theTrackable.markDirty();
    }
    
    public interface DataStealer
    {
        public abstract byte[] getData(DataBufferByte p0, int p1);
        
        public abstract short[] getData(DataBufferUShort p0, int p1);
        
        public abstract int[] getData(DataBufferInt p0, int p1);
        
        public abstract StateTrackableDelegate getTrackable(DataBuffer p0);
        
        public abstract void setTrackable(DataBuffer p0, StateTrackableDelegate p1);
    }
}
